Summary:       A library for boosting TCP and UDP traffic (over RDMA hardware)
Name:          libvma
Version:       9.8.20
Release:       3%{?dist}
License:       GPLv2 or BSD
Url:           https://github.com/Mellanox/libvma
Source0:       %{url}/archive/%{version}/%{name}-%{version}.tar.gz
Patch5000:     0001-libvma-9.8.20-add-support-for-loongarch64.patch

BuildRequires: pkgconfig automake autoconf libtool gcc-c++ rdma-core-devel systemd-rpm-macros
BuildRequires: pkgconfig(libnl-3.0) pkgconfig(libnl-route-3.0) make

ExclusiveArch: x86_64 aarch64 loongarch64

%description
libvma is a LD_PRELOAD-able library that boosts performance of TCP and UDP traffic. It allows
application written over standard socket API to handle fast path data traffic from user space
over Ethernet and/or Infiniband with full network stack bypass and get better throughput,
latency and packets/sec rate.

No application binary change is required for that. libvma is supported by RDMA capable devices
that support "verbs" IBV_QPT_RAW_PACKET QP for Ethernet and/or IBV_QPT_UD QP for IPoIB.

%package devel
Summary: Header files required to develop with libvma
Requires: %{name} = %{version}-%{release}

%description devel
This package includes headers for building programs with libvma's interfaces.

%package utils
Summary: Utilities used with libvma
Requires: %{name} = %{version}-%{release}

%description utils
This package contains the tool for collecting and analyzing libvma statistic.

%prep
%autosetup -n %{name}-%{version} -p1

%build
export revision=1
PRJ_RELEASE=1 ./autogen.sh

%configure
%make_build

%install
%make_install

find %{buildroot}%{_libdir} -name '*.la' -delete
install -D -m 644 contrib/scripts/vma.service %{buildroot}/%{_prefix}/lib/systemd/system/vma.service
rm -f %{buildroot}/%{_sysconfdir}/init.d/vma

%post
%systemd_post vma.service

%preun
%systemd_preun vma.service

%postun
%systemd_postun_with_restart vma.service

%files
%license LICENSE
%dir %{_pkgdocdir}
%doc %{_pkgdocdir}/README
%doc %{_pkgdocdir}/CHANGES
%{_libdir}/%{name}.so*
%config(noreplace) %{_sysconfdir}/libvma.conf
%{_sbindir}/vmad
%{_prefix}/lib/systemd/system/vma.service
%{_mandir}/man7/vma.*
%{_mandir}/man8/vmad.*

%files devel
%dir %{_includedir}/mellanox
%{_includedir}/mellanox/vma_extra.h

%files utils
%{_bindir}/vma_stats
%{_mandir}/man8/vma_stats.*

%changelog
* Wed May 22 2024 Pengda Dou <doupengda@loongson.cn> - 9.8.20-3
- [Type] other
- [DESC] add support for loongarch64

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 9.8.20-2
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Jul 10 2023 Shuo Wang <abushwang@tencent.com> - 9.8.20-1
- update to 9.8.20

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 9.6.4-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 9.6.4-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Dec 1 2022 Shuo Wang <abushwang@tencent.com> - 9.6.4-1
- initial build
